package custom.PVPCB;

import java.util.StringTokenizer;

import javolution.text.TextBuilder;
import net.l2emuproject.Config;
import net.l2emuproject.gameserver.cache.HtmCache;
import net.l2emuproject.gameserver.communitybbs.CommunityBoard;
import net.l2emuproject.gameserver.communitybbs.IBBSHandler;
import net.l2emuproject.gameserver.communitybbs.Manager.BaseBBSManager;
import net.l2emuproject.gameserver.datatables.CharTemplateTable;
import net.l2emuproject.gameserver.datatables.ItemTable;
import net.l2emuproject.gameserver.model.actor.instance.L2PcInstance;
import net.l2emuproject.gameserver.model.base.ClassId;
import net.l2emuproject.gameserver.network.SystemMessageId;
import net.l2emuproject.gameserver.network.serverpackets.SystemMessage;

public class ClassBBSManager extends BaseBBSManager implements IBBSHandler
{
	@Override
	public String getBoard()
	{
		return "101";
	}

	private static String[] _COMMANDS = { "class", "changeclass" };

	@Override
	public String[] getCommands()
	{
		return _COMMANDS;
	}

	@Override
	public String handleCommand(L2PcInstance activeChar, String command, String param)
	{
		if(command.equals("class"))
		{
			TextBuilder sb = new TextBuilder();
			ClassId classId = activeChar.getClassId();
			int level = activeChar.getLevel();
			int jobLevel = classId.level();
			int newJobLevel = jobLevel + 1;

			if(level >= 20 && jobLevel == 0 || level >= 40 && jobLevel == 1 || level >= 76 && jobLevel == 2 && Config.CLASS_MASTER_SETTINGS.isAllowed(newJobLevel))
			{
					sb.append("<center> <font color=F2C202>" + activeChar.getName() + "</font>    <font color=F2C202>" + activeChar.getClassId().name() + "</font></center><br>");
					sb.append("<center>  :</center><br>");

					for(ClassId child : ClassId.values())
					{
						if(child.childOf(classId) && child.level() == newJobLevel)
						{
							sb.append("<br><center><button value=\"" + CharTemplateTable.getClassNameById(child.getId()) + "\" action=\"bypass -h _bbschangeclass ;" + child.getId() + "\" width=175 height=18 back=\"L2UI_ct1.button_df\" fore=\"L2UI_ct1.button_df\"></center>");
						}
					}
					if((Config.CLASS_MASTER_SETTINGS.getRequireItems(newJobLevel) != null) && (!Config.CLASS_MASTER_SETTINGS.getRequireItems(newJobLevel).isEmpty()))
					{
						sb.append("<br><br><center>  :</center>");
						sb.append("<center><table width=200>");
						for(Integer _itemId : Config.CLASS_MASTER_SETTINGS.getRequireItems(newJobLevel).keySet())
						{
							int _count = Config.CLASS_MASTER_SETTINGS.getRequireItems(newJobLevel).get(_itemId).intValue();
							sb.append("<tr><td><center><font color=\"LEVEL\">" + _count + "</font></center></td><td><center>" + ItemTable.getInstance().getTemplate(_itemId.intValue()).getName() + "</center></td></tr>");
						}
						sb.append("</table></center><br>");
					}
			}
			else
			{
				switch(jobLevel)
				{
					case 0:
						if(Config.CLASS_MASTER_SETTINGS.isAllowed(1))
						{
							sb.append(" <font color=F2C202>" + activeChar.getName() + "</font>    <font color=F2C202>" + activeChar.getClassId().name() + "</font><br>");
							sb.append("        : <font color=F2C202>20- </font><br>");
							sb.append("      <font color=F2C202>76- </font><br>");
							sb.append("        <font color=F2C202>76- </font><br>");
						}
						else if(Config.CLASS_MASTER_SETTINGS.isAllowed(2))
							sb.append("   1 .<br>");
						else if(Config.CLASS_MASTER_SETTINGS.isAllowed(3))
							sb.append("   2 .<br>");
						else
							sb.append("     .<br>");
						break;
					case 1:
						if(Config.CLASS_MASTER_SETTINGS.isAllowed(2))
						{
							sb.append(" <font color=F2C202>" + activeChar.getName() + "</font>    <font color=F2C202>" + activeChar.getClassId().name() + "</font><br>");
							sb.append("        : <font color=F2C202>40- </font><br>");
							sb.append("      <font color=F2C202>76- </font><br>");
							sb.append("        <font color=F2C202>76- </font><br>");
						}
						else if(Config.CLASS_MASTER_SETTINGS.isAllowed(3))
							sb.append("   2 .<br>");
						else
							sb.append("     .<br>");
						break;
					case 2:
						if(Config.CLASS_MASTER_SETTINGS.isAllowed(3))
						{
							sb.append(" <font color=F2C202>" + activeChar.getName() + "</font>    <font color=F2C202>" + activeChar.getClassId().name() + "</font><br>");
							sb.append("        : <font color=F2C202>76- </font><br>");
							sb.append("      <font color=F2C202>76- </font><br>");
							sb.append("        <font color=F2C202>76- </font><br>");
						}
						else
							sb.append("     .<br>");
						break;
					case 3:
						sb.append(" <font color=F2C202>" + activeChar.getName() + "</font>    <font color=F2C202>" + activeChar.getClassId().name() + "</font><br>");
						sb.append("     <br><br>");
						if(level >= 76)
						{
							sb.append("  <font color=F2C202>76- </font>    <br>");
							if(!activeChar.isNoble())
							{
								sb.append("   .   ''.<br>");
							}
							else
							{
								sb.append("  .     .<br>");
							}
						}
				}
				sb.append("<br>");
			}

			String content = HtmCache.getInstance().getHtm("data/html/CommunityBoard/100.htm");
			content = content.replace("%classmaster%", sb.toString());
			separateAndSend(content, activeChar);
		}

		if(command.equals("changeclass"))
		{
			StringTokenizer st = new StringTokenizer(param, ";");
			int val = Short.parseShort(st.nextToken());
			ClassId classId = activeChar.getClassId();
			ClassId newClassId = ClassId.values()[val];

			int level = activeChar.getLevel();
			int jobLevel = classId.level();
			int newJobLevel = newClassId.level();

			if(!Config.CLASS_MASTER_SETTINGS.isAllowed(newJobLevel))
				return null;
			if(!newClassId.childOf(classId))
				return null;
			if(newJobLevel != jobLevel + 1)
				return null;
			if(level < 20 && newJobLevel > 1)
				return null;
			if(level < 40 && newJobLevel > 2)
				return null;
			if(level < 76 && newJobLevel > 3)
			{ 
				return null; 
			}

			if(!Config.CLASS_MASTER_SETTINGS.getRewardItems(newJobLevel).isEmpty() && activeChar.getWeightPenalty() >= 3 || activeChar.getInventoryLimit() * 0.8D <= activeChar.getInventory().getSize())
			{
				activeChar.sendPacket(new SystemMessage(SystemMessageId.INVENTORY_LESS_THAN_80_PERCENT));
				return null;
			}

			for(Integer _itemId : Config.CLASS_MASTER_SETTINGS.getRequireItems(newJobLevel).keySet())
			{
				int _count = Config.CLASS_MASTER_SETTINGS.getRequireItems(newJobLevel).get(_itemId).intValue();
				if(activeChar.getInventory().getInventoryItemCount(_itemId.intValue(), -1) < _count)
				{
					activeChar.sendPacket(SystemMessageId.NOT_ENOUGH_ITEMS);
					return null;
				}
			}
			for(Integer _itemId : Config.CLASS_MASTER_SETTINGS.getRequireItems(newJobLevel).keySet())
			{
				int _count = Config.CLASS_MASTER_SETTINGS.getRequireItems(newJobLevel).get(_itemId).intValue();
				activeChar.destroyItemByItemId("ClassMaster", _itemId.intValue(), _count, activeChar, true);
			}
			for(Integer _itemId : Config.CLASS_MASTER_SETTINGS.getRewardItems(newJobLevel).keySet())
			{
				int _count = Config.CLASS_MASTER_SETTINGS.getRewardItems(newJobLevel).get(_itemId).intValue();
				activeChar.addItem("ClassMaster", _itemId.intValue(), _count, activeChar, true);
				if(Config.CLASS_MASTER_HILLERS && val == 97 || val == 105 || val == 112)
				{
					switch(val)
					{
						case 97:
							activeChar.addItem("ClassMaster", 15307, 1, activeChar, true);
							break;
						case 105:
							activeChar.addItem("ClassMaster", 15308, 1, activeChar, true);
							break;
						case 112:
							activeChar.addItem("ClassMaster", 15309, 4, activeChar, true);
					}

				}

			}

			changeClass(activeChar, val);

			activeChar.rewardSkills();

			if(newJobLevel == 3)
				activeChar.sendPacket(SystemMessageId.THIRD_CLASS_TRANSFER);
			else
			{
				activeChar.sendPacket(SystemMessageId.CLASS_TRANSFER);
			}
			TextBuilder sb = new TextBuilder();
			sb.append("<br>");
			sb.append("<center>,   : <font color=\"LEVEL\">" + CharTemplateTable.getClassNameById(activeChar.getClassId().getId()) + "</font>.</center>");
			String content = HtmCache.getInstance().getHtm("data/html/CommunityBoard/100.htm");
			content = content.replace("%classmaster%", sb.toString());
			separateAndSend(content, activeChar);
			activeChar.refreshOverloaded();
			activeChar.refreshExpertisePenalty();
		}
		return null;
	}

	private void changeClass(L2PcInstance player, int val)
	{
		player.setClassId(val);

		if(player.isSubClassActive())
			player.getSubClasses().get(player.getClassIndex()).setClassId(player.getActiveClass());
		else
		{
			player.setBaseClass(player.getActiveClass());
		}
		player.broadcastUserInfo();
		player.broadcastClassIcon();
	}

	public static void main(String[] args)
	{
		CommunityBoard.getInstance().registerBBSHandler(new ClassBBSManager());
	}

	@Override
	public void parsecmd(String command, L2PcInstance activeChar)
	{}

	@Override
	public void parsewrite(String arg0, String arg1, String arg2, String arg3, String arg4, L2PcInstance arg5)
	{}
}