package custom.PVPCB;

import java.util.StringTokenizer;

import javolution.text.TextBuilder;
import net.l2emuproject.gameserver.cache.HtmCache;
import net.l2emuproject.gameserver.communitybbs.CommunityBoard;
import net.l2emuproject.gameserver.communitybbs.IBBSHandler;
import net.l2emuproject.gameserver.communitybbs.Manager.BaseBBSManager;
import net.l2emuproject.gameserver.datatables.ItemTable;
import net.l2emuproject.gameserver.model.L2ItemInstance;
import net.l2emuproject.gameserver.model.actor.instance.L2PcInstance;
import net.l2emuproject.gameserver.network.SystemMessageId;
import net.l2emuproject.gameserver.templates.item.L2EtcItem;
import net.l2emuproject.gameserver.templates.item.L2Item;

public class EnchantBBSManager extends BaseBBSManager implements IBBSHandler
{
	@Override
	public String getBoard()
	{
		return "101";
	}

	private static String[] _COMMANDS = { "echant", "enchlistpage", "enchlistpageAtrChus", "enchlistpageAtr", "enchantgo", "enchantgoAtr" };

	@Override
	public String[] getCommands()
	{
		return _COMMANDS;
	}

	@Override
	public String handleCommand(L2PcInstance activeChar, String command, String param)
	{
		if(command.equals("echant"))
		{
			String name = "None Name";
			name = ItemTable.getInstance().getTemplate(ConfigBBSManager.ALT_CB_ENCH_ITEM).getName();
			TextBuilder sb = new TextBuilder();
			sb.append("<table width=400>");
			L2ItemInstance arr[] = activeChar.getInventory().getItems();
			int len = arr.length;
			for(int i = 0; i < len; i++)
			{
				L2ItemInstance _item = arr[i];
				if(_item == null || (_item.getItem() instanceof L2EtcItem) || !_item.isEquipped() || _item.isHeroItem() || _item.getItem().getCrystalType() == L2Item.CRYSTAL_NONE || _item.getItemId() >= 7816 && _item.getItemId() <= 7831 || _item.isShadowItem() || _item.isEtcItem() || _item.isWear() || _item.getEnchantLevel() >= ConfigBBSManager.ALT_CB_ENCH_MAX + 1)
					continue;
				sb.append((new StringBuilder()).append("<tr><td><img src=icon.").append(ItemTableBBSManager.getIcon(_item.getItem().getItemId())).append(" width=32 height=32></td><td>").toString());
				sb.append((new StringBuilder()).append("<font color=\"LEVEL\">").append(_item.getItem().getName()).append(" ").append(_item.getEnchantLevel() <= 0 ? "" : (new StringBuilder()).append("</font><br1><font color=3293F3> : +").append(_item.getEnchantLevel()).toString()).append("</font><br1>").toString());

				sb.append((new StringBuilder()).append(" : <font color=\"LEVEL\">").append(name).append("</font>").toString());
				sb.append("<img src=\"l2ui.squaregray\" width=\"170\" height=\"1\">");
				sb.append("</td>");
				if(ConfigBBSManager.ALT_CB_ENCH_ALLOW)
				{
					sb.append("<td>");
					sb.append((new StringBuilder()).append("<button value=\"\" action=\"bypass -h _bbsenchlistpage ;").append(_item.getObjectId()).append("\" width=75 height=18 back=\"L2UI_ct1.button_df\" fore=\"L2UI_ct1.button_df\">").toString());
					sb.append("</td>");
				}
				if(ConfigBBSManager.ALT_CB_ENCH_ATR_ALLOW)
				{
					sb.append("<td>");
					sb.append((new StringBuilder()).append("<button value=\"\" action=\"bypass -h _bbsenchlistpageAtrChus ;").append(_item.getObjectId()).append("\" width=75 height=18 back=\"L2UI_ct1.button_df\" fore=\"L2UI_ct1.button_df\">").toString());
					sb.append("</td>");
				}
				sb.append("</tr>");

			}
			sb.append("</table>");
			String content = HtmCache.getInstance().getHtm("data/html/CommunityBoard/804.htm");
			content = content.replace("%enchanter%", sb.toString());
			separateAndSend(content, activeChar);
		}
		if(command.equals("enchlistpage"))
		{
			StringTokenizer st = new StringTokenizer(param, ";");
			int ItemForEchantObjID = Integer.parseInt(st.nextToken());
			int price = 0;
			double mod = 0;
			String name = "None Name";
			name = ItemTable.getInstance().getTemplate(ConfigBBSManager.ALT_CB_ENCH_ITEM).getName();
			L2ItemInstance EhchantItem = activeChar.getInventory().getItemByObjectId(ItemForEchantObjID);
			if(EhchantItem.getItem().getCrystalType() == L2Item.CRYSTAL_D)
			{
				if(EhchantItem.getItem().getType2() == L2Item.TYPE2_WEAPON)
				{
					price = ConfigBBSManager.ALT_CB_ENCH_D_WEAPON_PRICE;
					mod = ConfigBBSManager.ALT_CB_ENCH_D_PRICE_MOD;
				}
				else
				{
					price = ConfigBBSManager.ALT_CB_ENCH_D_ARMOR_PRICE;
					mod = ConfigBBSManager.ALT_CB_ENCH_D_PRICE_MOD;
				}

			}
			else if(EhchantItem.getItem().getCrystalType() == L2Item.CRYSTAL_C)
			{
				if(EhchantItem.getItem().getType2() == L2Item.TYPE2_WEAPON)
				{
					price = ConfigBBSManager.ALT_CB_ENCH_C_WEAPON_PRICE;
					mod = ConfigBBSManager.ALT_CB_ENCH_C_PRICE_MOD;
				}
				else
				{
					price = ConfigBBSManager.ALT_CB_ENCH_C_ARMOR_PRICE;
					mod = ConfigBBSManager.ALT_CB_ENCH_C_PRICE_MOD;
				}
			}
			else if(EhchantItem.getItem().getCrystalType() == L2Item.CRYSTAL_B)
			{
				if(EhchantItem.getItem().getType2() == L2Item.TYPE2_WEAPON)
				{
					price = ConfigBBSManager.ALT_CB_ENCH_B_WEAPON_PRICE;
					mod = ConfigBBSManager.ALT_CB_ENCH_B_PRICE_MOD;
				}
				else
				{
					price = ConfigBBSManager.ALT_CB_ENCH_B_ARMOR_PRICE;
					mod = ConfigBBSManager.ALT_CB_ENCH_B_PRICE_MOD;
				}
			}
			else if(EhchantItem.getItem().getCrystalType() == L2Item.CRYSTAL_A)
			{
				if(EhchantItem.getItem().getType2() == L2Item.TYPE2_WEAPON)
				{
					price = ConfigBBSManager.ALT_CB_ENCH_A_WEAPON_PRICE;
					mod = ConfigBBSManager.ALT_CB_ENCH_A_PRICE_MOD;
				}
				else
				{
					price = ConfigBBSManager.ALT_CB_ENCH_A_ARMOR_PRICE;
					mod = ConfigBBSManager.ALT_CB_ENCH_A_PRICE_MOD;
				}
			}
			else if(EhchantItem.getItem().getCrystalType() == L2Item.CRYSTAL_S)
			{
				if(EhchantItem.getItem().getType2() == L2Item.TYPE2_WEAPON)
				{
					price = ConfigBBSManager.ALT_CB_ENCH_S_WEAPON_PRICE;
					mod = ConfigBBSManager.ALT_CB_ENCH_S_PRICE_MOD;
				}
				else
				{
					price = ConfigBBSManager.ALT_CB_ENCH_S_ARMOR_PRICE;
					mod = ConfigBBSManager.ALT_CB_ENCH_S_PRICE_MOD;
				}
			}
			else if(EhchantItem.getItem().getCrystalType() == L2Item.CRYSTAL_S80)
			{
				if(EhchantItem.getItem().getType2() == L2Item.TYPE2_WEAPON)
				{
					price = ConfigBBSManager.ALT_CB_ENCH_S80_WEAPON_PRICE;
					mod = ConfigBBSManager.ALT_CB_ENCH_S80_PRICE_MOD;
				}
				else
				{
					price = ConfigBBSManager.ALT_CB_ENCH_S80_ARMOR_PRICE;
					mod = ConfigBBSManager.ALT_CB_ENCH_S80_PRICE_MOD;
				}
			}
			else if(EhchantItem.getItem().getCrystalType() == L2Item.CRYSTAL_S84)
			{
				if(EhchantItem.getItem().getType2() == L2Item.TYPE2_WEAPON)
				{
					price = ConfigBBSManager.ALT_CB_ENCH_S84_WEAPON_PRICE;
					mod = ConfigBBSManager.ALT_CB_ENCH_S84_PRICE_MOD;
				}
				else
				{
					price = ConfigBBSManager.ALT_CB_ENCH_S84_ARMOR_PRICE;
					mod = ConfigBBSManager.ALT_CB_ENCH_S84_PRICE_MOD;
				}
			}
			TextBuilder sb = new TextBuilder();
			sb.append("    :<br1><table width=300>");
			sb.append((new StringBuilder()).append("<tr><td width=32><img src=icon.").append(ItemTableBBSManager.getIcon(EhchantItem.getItem().getItemId())).append(" width=32 height=32> <img src=\"l2ui.squaregray\" width=\"32\" height=\"1\"></td><td width=236><center>").toString());
			sb.append((new StringBuilder()).append("<font color=\"LEVEL\">").append(EhchantItem.getItem().getName()).append(" ").append(EhchantItem.getEnchantLevel() <= 0 ? "" : (new StringBuilder()).append("</font><br1><font color=3293F3> : +").append(EhchantItem.getEnchantLevel()).toString()).append("</font><br1>").toString());

			sb.append((new StringBuilder()).append("  : <font color=\"LEVEL\">").append(name).append("</font>").toString());
			sb.append("<img src=\"l2ui.squaregray\" width=\"236\" height=\"1\"><center></td>");
			sb.append((new StringBuilder()).append("<td width=32><img src=icon.").append(ItemTableBBSManager.getIcon(EhchantItem.getItem().getItemId())).append(" width=32 height=32> <img src=\"l2ui.squaregray\" width=\"32\" height=\"1\"></td>").toString());
			sb.append("</tr>");
			sb.append("</table>");
			sb.append("<br1>");
			sb.append("<br1>");
			sb.append("<table border=0 width=400>");
			for(int $i = ConfigBBSManager.ALT_CB_ENCH_MIN - 2; $i <= ConfigBBSManager.ALT_CB_ENCH_MAX; $i++)
			{
				if($i % 2 == 0)
				{
					sb.append("<td width=200>");
					sb.append("<center><button value=\" +" + $i + " (:" + (int) ((double) price * (mod + ($i * price))) + " " + name + ")\" action=\"bypass -h _bbsenchantgo ;" + $i + ";" + (int) ((double) price * (mod + ($i * price))) + ";" + ItemForEchantObjID + "\" width=200 height=20 back=\"L2UI_CT1.Button_DF\" fore=\"L2UI_CT1.Button_DF\"></center>");
					sb.append("</td><tr>");
				}
				else
				{
					sb.append("</tr><td width=200>");
					sb.append("<center><button value=\" +" + $i + " (:" + (int) ((double) price * (mod + ($i * price))) + " " + name + ")\" action=\"bypass -h _bbsenchantgo ;" + $i + ";" + (int) ((double) price * (mod + ($i * price))) + ";" + ItemForEchantObjID + "\" width=200 height=20 back=\"L2UI_CT1.Button_DF\" fore=\"L2UI_CT1.Button_DF\"></center>");
					sb.append("</td>");
				}
			}
			sb.append("</table><br1><button value=\"\" action=\"bypass -h _bbsechant\" width=70 height=18 back=\"L2UI_ct1.button_df\" fore=\"L2UI_ct1.button_df\">");
			String content = HtmCache.getInstance().getHtm("data/html/CommunityBoard/804.htm");
			content = content.replace("%enchanter%", sb.toString());
			separateAndSend(content, activeChar);
		}
		if(command.equals("enchlistpageAtrChus"))
		{
			StringTokenizer st = new StringTokenizer(param, ";");
			int ItemForEchantObjID = Integer.parseInt(st.nextToken());
			String name = "None Name";
			name = ItemTable.getInstance().getTemplate(ConfigBBSManager.ALT_CB_ENCH_ITEM).getName();
			L2ItemInstance EhchantItem = activeChar.getInventory().getItemByObjectId(ItemForEchantObjID);

			TextBuilder sb = new TextBuilder();
			sb.append("     :<br1><table width=300>");
			sb.append((new StringBuilder()).append("<tr><td width=32><img src=icon.").append(ItemTableBBSManager.getIcon(EhchantItem.getItem().getItemId())).append(" width=32 height=32> <img src=\"l2ui.squaregray\" width=\"32\" height=\"1\"></td><td width=236><center>").toString());
			sb.append((new StringBuilder()).append("<font color=\"LEVEL\">").append(EhchantItem.getItem().getName()).append(" ").append(EhchantItem.getEnchantLevel() <= 0 ? "" : (new StringBuilder()).append("</font><br1><font color=3293F3> : +").append(EhchantItem.getEnchantLevel()).toString()).append("</font><br1>").toString());

			sb.append((new StringBuilder()).append("  : <font color=\"LEVEL\">").append(name).append("</font>").toString());
			sb.append("<img src=\"l2ui.squaregray\" width=\"236\" height=\"1\"><center></td>");
			sb.append((new StringBuilder()).append("<td width=32><img src=icon.").append(ItemTableBBSManager.getIcon(EhchantItem.getItem().getItemId())).append(" width=32 height=32> <img src=\"l2ui.squaregray\" width=\"32\" height=\"1\"></td>").toString());
			sb.append("</tr>");
			sb.append("</table>");
			sb.append("<br1>");
			sb.append("<br1>");
			sb.append("<table border=0 width=400><tr><td width=200>");
			sb.append("<center><img src=icon.etc_wind_stone_i00 width=32 height=32></center><br1>");
			sb.append("<button value=\"Wind \" action=\"bypass -h _bbsenchlistpageAtr ;2;" + ItemForEchantObjID + "\" width=200 height=20 back=\"L2UI_CT1.Button_DF\" fore=\"L2UI_CT1.Button_DF\">");
			sb.append("<br1><center><img src=icon.etc_earth_stone_i00 width=32 height=32></center><br1>");
			sb.append("<button value=\"Earth \" action=\"bypass -h _bbsenchlistpageAtr ;3;" + ItemForEchantObjID + "\" width=200 height=20 back=\"L2UI_CT1.Button_DF\" fore=\"L2UI_CT1.Button_DF\">");
			sb.append("<br1><center><img src=icon.etc_fire_stone_i00 width=32 height=32></center><br1>");
			sb.append("<button value=\"Fire \" action=\"bypass -h _bbsenchlistpageAtr ;0;" + ItemForEchantObjID + "\" width=200 height=20 back=\"L2UI_CT1.Button_DF\" fore=\"L2UI_CT1.Button_DF\">");
			sb.append("</td><td width=200>");
			sb.append("<center><img src=icon.etc_water_stone_i00 width=32 height=32></center><br1>");
			sb.append("<button value=\"Water \" action=\"bypass -h _bbsenchlistpageAtr ;1;" + ItemForEchantObjID + "\" width=200 height=20 back=\"L2UI_CT1.Button_DF\" fore=\"L2UI_CT1.Button_DF\">");
			sb.append("<br1><center><img src=icon.etc_holy_stone_i00 width=32 height=32></center><br1>");
			sb.append("<button value=\"Divine \" action=\"bypass -h _bbsenchlistpageAtr ;4;" + ItemForEchantObjID + "\" width=200 height=20 back=\"L2UI_CT1.Button_DF\" fore=\"L2UI_CT1.Button_DF\">");
			sb.append("<br1><center><img src=icon.etc_unholy_stone_i00 width=32 height=32></center><br1>");
			sb.append("<button value=\"Dark \" action=\"bypass -h _bbsenchlistpageAtr ;5;" + ItemForEchantObjID + "\" width=200 height=20 back=\"L2UI_CT1.Button_DF\" fore=\"L2UI_CT1.Button_DF\">");
			sb.append("</td></tr></table><br1><button value=\"\" action=\"bypass -h _bbsechant\" width=70 height=18 back=\"L2UI_ct1.button_df\" fore=\"L2UI_ct1.button_df\">");
			String content = HtmCache.getInstance().getHtm("data/html/CommunityBoard/804.htm");
			content = content.replace("%enchanter%", sb.toString());
			separateAndSend(content, activeChar);
		}
		if(command.equals("enchlistpageAtr"))
		{
			StringTokenizer st = new StringTokenizer(param, ";");
			int AtributType = Integer.parseInt(st.nextToken());
			int ItemForEchantObjID = Integer.parseInt(st.nextToken());
			int price = 0;
			double mod = 0;
			String ElementName = "";
			if(AtributType == 0)
			{
				ElementName = "Fire";
			}
			else if(AtributType == 1)
			{
				ElementName = "Water";
			}
			else if(AtributType == 2)
			{
				ElementName = "Wind";
			}
			else if(AtributType == 3)
			{
				ElementName = "Earth";
			}
			else if(AtributType == 4)
			{
				ElementName = "Divine";
			}
			else if(AtributType == 5)
			{
				ElementName = "Dark";
			}
			String name = "None Name";
			name = ItemTable.getInstance().getTemplate(ConfigBBSManager.ALT_CB_ENCH_ITEM).getName();
			L2ItemInstance EhchantItem = activeChar.getInventory().getItemByObjectId(ItemForEchantObjID);
			if(EhchantItem.getItem().getCrystalType() == L2Item.CRYSTAL_S)
			{
				if(EhchantItem.getItem().getType2() == L2Item.TYPE2_WEAPON)
				{
					price = 10;
					mod = 1.5;
				}
				else
				{
					price = 8;
					mod = 1.5;
				}
			}
			else if(EhchantItem.getItem().getCrystalType() == L2Item.CRYSTAL_S80)
			{
				if(EhchantItem.getItem().getType2() == L2Item.TYPE2_WEAPON)
				{
					price = 12;
					mod = 1.6;
				}
				else
				{
					price = 10;
					mod = 1.6;
				}
			}
			else if(EhchantItem.getItem().getCrystalType() == L2Item.CRYSTAL_S84)
			{
				if(EhchantItem.getItem().getType2() == L2Item.TYPE2_WEAPON)
				{
					price = 14;
					mod = 1.7;
				}
				else
				{
					price = 12;
					mod = 1.7;
				}
			}
			TextBuilder sb = new TextBuilder();
			sb.append(" : <font color=\"LEVEL\">" + ElementName + "</font><br1>    :<br1><table width=300>");
			sb.append((new StringBuilder()).append("<tr><td width=32><img src=icon.").append(ItemTableBBSManager.getIcon(EhchantItem.getItem().getItemId())).append(" width=32 height=32> <img src=\"l2ui.squaregray\" width=\"32\" height=\"1\"></td><td width=236><center>").toString());
			sb.append((new StringBuilder()).append("<font color=\"LEVEL\">").append(EhchantItem.getItem().getName()).append(" ").append(EhchantItem.getEnchantLevel() <= 0 ? "" : (new StringBuilder()).append("</font><br1><font color=3293F3> : +").append(EhchantItem.getEnchantLevel()).toString()).append("</font><br1>").toString());

			sb.append((new StringBuilder()).append("  : <font color=\"LEVEL\">").append(name).append("</font>").toString());
			sb.append("<img src=\"l2ui.squaregray\" width=\"236\" height=\"1\"><center></td>");
			sb.append((new StringBuilder()).append("<td width=32><img src=icon.").append(ItemTableBBSManager.getIcon(EhchantItem.getItem().getItemId())).append(" width=32 height=32> <img src=\"l2ui.squaregray\" width=\"32\" height=\"1\"></td>").toString());
			sb.append("</tr>");
			sb.append("</table>");
			sb.append("<br1>");
			sb.append("<br1>");
			if(EhchantItem.getItem().getCrystalType() == L2Item.CRYSTAL_S || EhchantItem.getItem().getCrystalType() == L2Item.CRYSTAL_S80 || EhchantItem.getItem().getCrystalType() == L2Item.CRYSTAL_S84)
			{
				sb.append("<table border=0 width=400><tr><td width=200>");
				sb.append("<button value=\" +25 (:" + (int) ((double) price * (mod + 68)) + " " + name + ")\" action=\"bypass -h _bbsenchantgoAtr ;25;" + AtributType + ";" + (int) ((double) price * (mod + 68)) + ";" + ItemForEchantObjID + "\" width=200 height=20 back=\"L2UI_CT1.Button_DF\" fore=\"L2UI_CT1.Button_DF\">");
				sb.append("<br1>");
				sb.append("<button value=\" +50 (:" + (int) ((double) price * (mod + 88)) + " " + name + ")\" action=\"bypass -h _bbsenchantgoAtr ;50;" + AtributType + ";" + (int) ((double) price * (mod + 88)) + ";" + ItemForEchantObjID + "\" width=200 height=20 back=\"L2UI_CT1.Button_DF\" fore=\"L2UI_CT1.Button_DF\">");
				sb.append("<br1>");
				sb.append("<button value=\" +75 (:" + (int) ((double) price * (mod + 108)) + " " + name + ")\" action=\"bypass -h _bbsenchantgoAtr ;75;" + AtributType + ";" + (int) ((double) price * (mod + 108)) + ";" + ItemForEchantObjID + "\" width=200 height=20 back=\"L2UI_CT1.Button_DF\" fore=\"L2UI_CT1.Button_DF\">");
				sb.append("</td><td width=200>");
				sb.append("<button value=\" +100 (:" + (int) ((double) price * (mod + 128)) + " " + name + ")\" action=\"bypass -h _bbsenchantgoAtr ;100;" + AtributType + ";" + (int) ((double) price * (mod + 128)) + ";" + ItemForEchantObjID + "\" width=200 height=20 back=\"L2UI_CT1.Button_DF\" fore=\"L2UI_CT1.Button_DF\">");
				sb.append("<br1>");
				sb.append("<button value=\" +125 (:" + (int) ((double) price * (mod + 148)) + " " + name + ")\" action=\"bypass -h _bbsenchantgoAtr ;125;" + AtributType + ";" + (int) ((double) price * (mod + 148)) + ";" + ItemForEchantObjID + "\" width=200 height=20 back=\"L2UI_CT1.Button_DF\" fore=\"L2UI_CT1.Button_DF\">");
				sb.append("<br1>");
				sb.append("<button value=\" +150 (:" + (int) ((double) price * (mod + 168)) + " " + name + ")\" action=\"bypass -h _bbsenchantgoAtr ;150;" + AtributType + ";" + (int) ((double) price * (mod + 168)) + ";" + ItemForEchantObjID + "\" width=200 height=20 back=\"L2UI_CT1.Button_DF\" fore=\"L2UI_CT1.Button_DF\">");
				sb.append("</td></tr></table><br1>");
			}
			else
			{
				sb.append("<table border=0 width=400><tr><td width=200>");
				sb.append("<br1>");
				sb.append("<br1>");
				sb.append("<br1>");
				sb.append("<br1>");
				sb.append("<center><font color=\"LEVEL\">    !</font></center>");
				sb.append("<br1>");
				sb.append("<br1>");
				sb.append("<br1>");
				sb.append("<br1>");
				sb.append("</td></tr></table><br1>");
			}
			sb.append("<button value=\"\" action=\"bypass -h _bbsechant\" width=70 height=18 back=\"L2UI_ct1.button_df\" fore=\"L2UI_ct1.button_df\">");
			String content = HtmCache.getInstance().getHtm("data/html/CommunityBoard/804.htm");
			content = content.replace("%enchanter%", sb.toString());
			separateAndSend(content, activeChar);
		}
		if(command.equals("enchantgo"))
		{
			StringTokenizer st = new StringTokenizer(param, ";");
			int EchantVal = Integer.parseInt(st.nextToken());
			int EchantPrice = Integer.parseInt(st.nextToken());
			int EchantObjID = Integer.parseInt(st.nextToken());
			L2Item item = ItemTable.getInstance().getTemplate(ConfigBBSManager.ALT_CB_ENCH_ITEM);
			L2ItemInstance pay = activeChar.getInventory().getItemByItemId(item.getItemId());
			L2ItemInstance EhchantItem = activeChar.getInventory().getItemByObjectId(EchantObjID);
			if(pay != null && pay.getCount() >= EchantPrice)
			{
				activeChar.getInventory().destroyItem("Enchant", pay, EchantPrice, activeChar, null);
				EhchantItem.setEnchantLevel(EchantVal);
				activeChar.broadcastUserInfo();
				activeChar.sendMessage("" + EhchantItem.getItem().getName() + "    " + EchantVal + ". .");
				handleCommand(activeChar, "echant", null);
			}
			else
			{
				activeChar.sendPacket(SystemMessageId.INCORRECT_ITEM_COUNT);
			}

		}
		if(command.equals("enchantgoAtr"))
		{
			StringTokenizer st = new StringTokenizer(param, ";");
			int EchantVal = Integer.parseInt(st.nextToken());
			int AtrType = Integer.parseInt(st.nextToken());
			int EchantPrice = Integer.parseInt(st.nextToken());
			int EchantObjID = Integer.parseInt(st.nextToken());
			L2Item item = ItemTable.getInstance().getTemplate(ConfigBBSManager.ALT_CB_ENCH_ITEM);
			L2ItemInstance pay = activeChar.getInventory().getItemByItemId(item.getItemId());
			L2ItemInstance EhchantItem = activeChar.getInventory().getItemByObjectId(EchantObjID);
			if(pay != null && pay.getCount() >= EchantPrice)
			{
				activeChar.getInventory().destroyItem("Enchant", pay, EchantPrice, activeChar, null);
				EhchantItem.setElementAttr((byte) AtrType, EchantVal);
				activeChar.broadcastUserInfo();
				activeChar.sendMessage("" + EhchantItem.getItem().getName() + "    " + EchantVal + ". .");
				handleCommand(activeChar, "echant", null);
			}
			else
			{
				activeChar.sendPacket(SystemMessageId.INCORRECT_ITEM_COUNT);
			}

		}
		return null;
	}

	public static void main(String[] args)
	{
		CommunityBoard.getInstance().registerBBSHandler(new EnchantBBSManager());
	}

	@Override
	public void parsecmd(String command, L2PcInstance activeChar)
	{}

	@Override
	public void parsewrite(String arg0, String arg1, String arg2, String arg3, String arg4, L2PcInstance arg5)
	{}
}