package custom.PVPCB;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;

import javolution.text.TextBuilder;
import net.l2emuproject.L2DatabaseFactory;
import net.l2emuproject.gameserver.cache.HtmCache;
import net.l2emuproject.gameserver.communitybbs.CommunityBoard;
import net.l2emuproject.gameserver.communitybbs.IBBSHandler;
import net.l2emuproject.gameserver.communitybbs.Manager.BaseBBSManager;
import net.l2emuproject.gameserver.model.actor.instance.L2PcInstance;

public class ServiceBBSManager extends BaseBBSManager implements IBBSHandler
{
	public class CBStatMan
	{
		public int PlayerId = 0; // 
		public String ChName = ""; //
		public int ChLvL = 0; //
		public int ChGameTime = 0; // 
		public int ChPk = 0; //
		public int ChPvP = 0; //
		public int ChOnOff = 0; //
		public int ChSex = 0; //
	}

	@Override
	public String getBoard()
	{
		return "101";
	}

	private static String[] _COMMANDS = { "stat", "statpk", "sms" };

	@Override
	public String[] getCommands()
	{
		return _COMMANDS;
	}

	@Override
	public String handleCommand(L2PcInstance activeChar, String command, String param)
	{
		if(command.equals("stat"))
		{
			showPvp(activeChar);
		}
		if(command.equals("statpk"))
		{
			showPK(activeChar);
		}
		if(command.equals("sms"))
		{
			showSMS(activeChar);
		}
		return null;

	}

	private void showSMS(L2PcInstance activeChar)
	{
		String content = HtmCache.getInstance().getHtm("data/html/CommunityBoard/303.htm");
		content = content.replace("%name%", activeChar.getName());
		separateAndSend(content, activeChar);
	}

	private void showPvp(L2PcInstance activeChar)
	{
		CBStatMan tp;
		Connection con = null;
		try
		{
			con = L2DatabaseFactory.getInstance().getConnection();
			PreparedStatement st = con.prepareStatement("SELECT * FROM characters ORDER BY pvpkills DESC LIMIT 20;");
			ResultSet rs = st.executeQuery();
			TextBuilder html = new TextBuilder();
			html.append("<center> 20 PVP</center>");
			html.append("");
			html.append("<table width=500 bgcolor=CCCCCC>");
			html.append("<tr>");
			html.append("<td width=250></td>");
			html.append("<td width=50>LvL</td>");
			html.append("<td width=50></td>");
			html.append("<td width=100>  </td>");
			html.append("<td width=50>PK</td>");
			html.append("<td width=50><font color=00CC00>PVP</font></td>");
			html.append("<td width=100></td>");
			html.append("</tr>");
			html.append("</table>");
			html.append("");
			html.append("<table width=500>");
			while(rs.next())
			{
				tp = new CBStatMan();
				tp.PlayerId = rs.getInt("charId");
				tp.ChName = rs.getString("char_name");
				tp.ChLvL = rs.getInt("level");
				tp.ChSex = rs.getInt("sex");
				tp.ChGameTime = rs.getInt("onlinetime");
				tp.ChPk = rs.getInt("pkkills");
				tp.ChPvP = rs.getInt("pvpkills");
				tp.ChOnOff = rs.getInt("online");
				String OnOff;
				String color;
				String sex;
				if(tp.ChSex == 1)
				{
					sex = "";
				}
				else
				{
					sex = "";
				}
				if(tp.ChOnOff == 1)
				{
					OnOff = "";
					color = "00CC00";
				}
				else
				{
					OnOff = "";
					color = "D70000";
				}
				html.append("<tr>");
				html.append("<td width=250>" + tp.ChName + "</td>");
				html.append("<td width=50>" + tp.ChLvL + "</td>");
				html.append("<td width=50>" + sex + "</td>");
				html.append("<td width=100>" + OnlineTime(tp.ChGameTime) + "</td>");
				html.append("<td width=50>" + tp.ChPk + "</td>");
				html.append("<td width=50><font color=00CC00>" + tp.ChPvP + "</font></td>");
				html.append("<td width=100><font color=" + color + ">" + OnOff + "</font></td>");
				html.append("</tr>");
			}
			html.append("</table>");

			String content = HtmCache.getInstance().getHtm("data/html/CommunityBoard/200.htm");
			content = content.replace("%stat%", html.toString());
			separateAndSend(content, activeChar);
		}
		catch(Exception e)
		{}
		finally
		{
			try
			{
				con.close();
			}
			catch(Exception e)
			{}
		}
	}

	private void showPK(L2PcInstance activeChar)
	{
		CBStatMan tp;
		Connection con = null;
		try
		{
			con = L2DatabaseFactory.getInstance().getConnection();
			PreparedStatement st = con.prepareStatement("SELECT * FROM characters ORDER BY pkkills DESC LIMIT 20;");
			ResultSet rs = st.executeQuery();
			TextBuilder html = new TextBuilder();
			html.append("<center> 20 PK</center>");
			html.append("");
			html.append("<table width=500 bgcolor=CCCCCC>");
			html.append("<tr>");
			html.append("<td width=250></td>");
			html.append("<td width=50>LvL</td>");
			html.append("<td width=50></td>");
			html.append("<td width=100>  </td>");
			html.append("<td width=50><font color=00CC00>PK</font></td>");
			html.append("<td width=50>PVP</td>");
			html.append("<td width=100></td>");
			html.append("</tr>");
			html.append("</table>");
			html.append("");
			html.append("<table width=500>");
			while(rs.next())
			{
				tp = new CBStatMan();
				tp.PlayerId = rs.getInt("charId");
				tp.ChName = rs.getString("char_name");
				tp.ChLvL = rs.getInt("level");
				tp.ChSex = rs.getInt("sex");
				tp.ChGameTime = rs.getInt("onlinetime");
				tp.ChPk = rs.getInt("pkkills");
				tp.ChPvP = rs.getInt("pvpkills");
				tp.ChOnOff = rs.getInt("online");
				String OnOff;
				String color;
				String sex;
				if(tp.ChSex == 1)
				{
					sex = "";
				}
				else
				{
					sex = "";
				}
				if(tp.ChOnOff == 1)
				{
					OnOff = "";
					color = "00CC00";
				}
				else
				{
					OnOff = "";
					color = "D70000";
				}
				html.append("<tr>");
				html.append("<td width=250>" + tp.ChName + "</td>");
				html.append("<td width=50>" + tp.ChLvL + "</td>");
				html.append("<td width=50>" + sex + "</td>");
				html.append("<td width=100>" + OnlineTime(tp.ChGameTime) + "</td>");
				html.append("<td width=50><font color=00CC00>" + tp.ChPk + "</font></td>");
				html.append("<td width=50>" + tp.ChPvP + "</td>");
				html.append("<td width=100><font color=" + color + ">" + OnOff + "</font></td>");
				html.append("</tr>");
			}
			html.append("</table>");

			String content = HtmCache.getInstance().getHtm("data/html/CommunityBoard/200.htm");
			content = content.replace("%stat%", html.toString());
			separateAndSend(content, activeChar);
		}
		catch(Exception e)
		{}
		finally
		{
			try
			{
				con.close();
			}
			catch(SQLException e)
			{
				e.printStackTrace();
			}
		}

	}

	String OnlineTime(int time)
	{
		long onlinetimeH;
		int onlinetimeM;
		if(time / 60 / 60 - 0.5 <= 0)
		{
			onlinetimeH = 0;
		}
		else
		{
			onlinetimeH = Math.round((time / 60 / 60) - 0.5);
		}
		onlinetimeM = Math.round(((time / 60 / 60) - onlinetimeH) * 60);
		return "" + onlinetimeH + " . " + onlinetimeM + " .";
	}

	public static void main(String[] args)
	{
		CommunityBoard.getInstance().registerBBSHandler(new ServiceBBSManager());
	}

	public void parsewrite(String ar1, String ar2, String ar3, String ar4, String ar5, L2PcInstance activeChar)
	{}

	public void parsecmd(String command, L2PcInstance activeChar)
	{}
}