//custom_scripts.cfg 
//custom/PVPCB/TeleportBBSManager.java 
//bypass -h _bbsteleto 50192 
//50192 id   custom_teleport 

package custom.PVPCB;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;

import javolution.text.TextBuilder;
import net.l2emuproject.L2DatabaseFactory;
import net.l2emuproject.gameserver.cache.HtmCache;
import net.l2emuproject.gameserver.communitybbs.CommunityBoard;
import net.l2emuproject.gameserver.communitybbs.IBBSHandler;
import net.l2emuproject.gameserver.communitybbs.Manager.BaseBBSManager;
import net.l2emuproject.gameserver.datatables.TeleportLocationTable;
import net.l2emuproject.gameserver.instancemanager.SiegeManager;
import net.l2emuproject.gameserver.instancemanager.TownManager;
import net.l2emuproject.gameserver.model.L2TeleportLocation;
import net.l2emuproject.gameserver.model.actor.instance.L2PcInstance;
import net.l2emuproject.gameserver.model.olympiad.Olympiad;
import net.l2emuproject.gameserver.network.SystemMessageId;

public class TeleportBBSManager extends BaseBBSManager implements IBBSHandler
{

	@Override
	public String getBoard()
	{
		return "101";
	}

	private static String[] _COMMANDS = { "tele", "teleto", "telesave", "teledel", "telegomy" };

	@Override
	public String[] getCommands()
	{
		return _COMMANDS;
	}

	public class CBteleport
	{
		public int TpId = 0; // Teport loc ID
		public String TpName = ""; // Loc name
		public int PlayerId = 0; // charID
		public int xC = 0; // Location coords
		public int yC = 0; //
		public int zC = 0; //
	}

	@Override
	public String handleCommand(L2PcInstance player, String command, String param)
	{

		if(command.equals("tele"))
		{
			showTp(player);
		}
		if(command.equals("telesave"))
		{
			String TpNameAdd = param;
			AddTp(player, TpNameAdd);
			showTp(player);
		}
		else if(command.equals("teledel"))
		{
			int TpNameDell = Integer.parseInt(param);
			delTp(player, TpNameDell);
			showTp(player);
		}
		else if(command.equals("telegomy"))
		{
			int TpToGo = Integer.parseInt(param);
			goTp(player, TpToGo);
			showTp(player);
		}
		if(command.equals("teleto"))
		{
			if(player != null)
			{
				if(player.isInCombat())
				{
					player.sendMessage("    .");
					return null;
				}
				if(player.isSitting())
				{
					player.sendMessage("  .");
					return null;
				}
				if(player.isChaotic())
				{
					player.sendMessage("   PK .");
					return null;
				}
				if(player.isInOlympiadMode() || Olympiad.getInstance().isRegistered(player) || player.getOlympiadGameId() != -1)
				{
					player.sendMessage("    .");
					return null;
				}
				if(player.isInFunEvent())
				{
					player.sendMessage("     .");
					return null;
				}
				if(player.isInJail())
				{
					player.sendMessage("    .");
					return null;
				}
				if(player.isInKarteiCube())
				{
					player.sendMessage("    KarteiCube.");
					return null;
				}
				if(player.isInUndergroundColiseum())
				{
					player.sendMessage("    Underground Coliseum.");
					return null;
				}

				if(player.isFlying())
				{
					player.sendMessage("    .");
					return null;
				}
				if(player.getInstanceId() > 0)
				{
					player.sendMessage("   .");
				}
				//####### 

				L2TeleportLocation clist = TeleportLocationTable.getInstance().getCustomTemplate(Integer.parseInt(param));
				int price = clist.getPrice();

				if(SiegeManager.getInstance().checkIfInZone(clist.getLocX(), clist.getLocY(), clist.getLocZ()))
				{
					player.sendMessage("    .");
					return null;
				}
				if(TownManager.getInstance().townHasCastleInSiege(clist.getLocX(), clist.getLocY(), clist.getLocZ()))
				{
					player.sendMessage("    .");
					return null;
				}

				if(price > 0 && player.getAdena() < price)
				{
					player.sendMessage("  .");
					return null;
				}

				if(price > 0)
					player.destroyItemByItemId("BBSGK", 57, price, null, true);

				player.teleToLocation(clist.getLocX(), clist.getLocY(), clist.getLocZ());
				//player.sendMessage("#"+price); 
			}
		}
		return null;
	}

	private void showTp(L2PcInstance activeChar)
	{
		CBteleport tp;
		Connection con = null;
		try
		{
			con = L2DatabaseFactory.getInstance().getConnection();
			PreparedStatement st = con.prepareStatement("SELECT * FROM comteleport WHERE charId=?;");
			st.setLong(1, activeChar.getObjectId());
			ResultSet rs = st.executeQuery();
			TextBuilder html = new TextBuilder();
			html.append("<table width=220>");
			while(rs.next())
			{
				tp = new CBteleport();
				tp.TpId = rs.getInt("TpId");
				tp.TpName = rs.getString("name");
				tp.PlayerId = rs.getInt("charId");
				tp.xC = rs.getInt("xPos");
				tp.yC = rs.getInt("yPos");
				tp.zC = rs.getInt("zPos");
				html.append("<tr>");
				html.append("<td>");
				html.append("<button value=\"" + tp.TpName + "\" action=\"bypass -h _bbstelegomy " + tp.TpId + "\" width=100 height=20 back=\"L2UI_ct1.button_df\" fore=\"L2UI_ct1.button_df\">");
				html.append("</td>");
				html.append("<td>");
				html.append("<button value=\"\" action=\"bypass -h _bbsteledel " + tp.TpId + "\" width=100 height=20 back=\"L2UI_ct1.button_df\" fore=\"L2UI_ct1.button_df\">");
				html.append("</td>");
				html.append("</tr>");
			}
			html.append("</table>");

			String content = HtmCache.getInstance().getHtm("data/html/CommunityBoard/50.htm");
			content = content.replace("%tp%", html.toString());
			separateAndSend(content, activeChar);
			return;

		}
		catch(Exception e)
		{}
		finally
		{
			try
			{
				con.close();
			}
			catch(Exception e)
			{}
		}

	}

	private void goTp(L2PcInstance activeChar, int TpToGo)
	{
		int priceTp = 2000000;

		if(activeChar.isDead() || activeChar.isAlikeDead() || activeChar.isCastingNow() || activeChar.isInCombat() || activeChar.isAttackingNow() || activeChar.isInOlympiadMode() || activeChar.isInJail() || activeChar.isFlying())
		{
			activeChar.sendMessage(" ");
			return;
		}
		if(priceTp > 0 && activeChar.getAdena() < priceTp)
		{
			activeChar.sendPacket(SystemMessageId.YOU_NOT_ENOUGH_ADENA);
			return;
		}

		else
		{
			if(priceTp > 0)
			{
				activeChar.reduceAdena("Teleport", priceTp, activeChar, true);
			}
			CBteleport tp;
			Connection con = null;
			try
			{
				con = L2DatabaseFactory.getInstance().getConnection();
				PreparedStatement st = con.prepareStatement("SELECT * FROM comteleport WHERE TpId=?;");
				st.setInt(1, TpToGo);
				ResultSet rs = st.executeQuery();
				while(rs.next())
				{

					tp = new CBteleport();
					tp.TpId = rs.getInt("TpId");
					tp.TpName = rs.getString("name");
					tp.PlayerId = rs.getInt("charId");
					tp.xC = rs.getInt("xPos");
					tp.yC = rs.getInt("yPos");
					tp.zC = rs.getInt("zPos");
					activeChar.teleToLocation(tp.xC, tp.yC, tp.zC);
				}
			}
			catch(Exception e)
			{}
			finally
			{
				try
				{
					con.close();
				}
				catch(Exception e)
				{}
			}

		}
	}

	private void delTp(L2PcInstance activeChar, int TpNameDell)
	{
		Connection conDel = null;
		try
		{
			conDel = L2DatabaseFactory.getInstance().getConnection();
			PreparedStatement stDel = conDel.prepareStatement("DELETE FROM comteleport WHERE charId=? AND TpId=?;");
			stDel.setInt(1, activeChar.getObjectId());
			stDel.setInt(2, TpNameDell);
			stDel.execute();
		}
		catch(Exception e)
		{}
		finally
		{
			try
			{
				conDel.close();
			}
			catch(Exception e)
			{}
		}

	}

	private void AddTp(L2PcInstance activeChar, String TpNameAdd)
	{
		if(activeChar.isDead() || activeChar.isAlikeDead() || activeChar.isCastingNow() || activeChar.isAttackingNow())
		{
			activeChar.sendMessage("     ");
			return;
		}

		if(activeChar.isInCombat())
		{
			activeChar.sendMessage("     ");
			return;
		}

		if(TpNameAdd.equals("") || TpNameAdd.equals(null))
		{
			activeChar.sendMessage("    ");
			return;
		}
		Connection con = null;
		try
		{
			con = L2DatabaseFactory.getInstance().getConnection();

			PreparedStatement st = con.prepareStatement("SELECT COUNT(*) FROM comteleport WHERE charId=?;");
			st.setLong(1, activeChar.getObjectId());
			ResultSet rs = st.executeQuery();
			rs.next();
			if(rs.getInt(1) <= 9)
			{
				PreparedStatement st1 = con.prepareStatement("SELECT COUNT(*) FROM comteleport WHERE charId=? AND name=?;");
				st1.setLong(1, activeChar.getObjectId());
				st1.setString(2, TpNameAdd);
				ResultSet rs1 = st1.executeQuery();
				rs1.next();
				if(rs1.getInt(1) == 0)
				{
					PreparedStatement stAdd = con.prepareStatement("INSERT INTO comteleport (charId,xPos,yPos,zPos,name) VALUES(?,?,?,?,?)");
					stAdd.setInt(1, activeChar.getObjectId());
					stAdd.setInt(2, activeChar.getX());
					stAdd.setInt(3, activeChar.getY());
					stAdd.setInt(4, activeChar.getZ());
					stAdd.setString(5, TpNameAdd);
					stAdd.execute();
				}
				else
				{
					PreparedStatement stAdd = con.prepareStatement("UPDATE comteleport SET xPos=?, yPos=?, zPos=? WHERE charId=? AND name=?;");
					stAdd.setInt(1, activeChar.getObjectId());
					stAdd.setInt(2, activeChar.getX());
					stAdd.setInt(3, activeChar.getY());
					stAdd.setInt(4, activeChar.getZ());
					stAdd.setString(5, TpNameAdd);
					stAdd.execute();
				}
			}
			else
			{
				activeChar.sendMessage("     10 ");
			}

		}
		catch(Exception e)
		{}
		finally
		{
			try
			{
				con.close();
			}
			catch(Exception e)
			{}
		}
	}

	public static void main(String[] args)
	{
		CommunityBoard.getInstance().registerBBSHandler(new TeleportBBSManager());
	}

	@Override
	public void parsecmd(String arg0, L2PcInstance arg1)
	{}

	@Override
	public void parsewrite(String arg0, String arg1, String arg2, String arg3, String arg4, L2PcInstance arg5)
	{}
}